function p = RWR(A, nSteps, laziness, p0)

n = length(A);
if (nargin < 4)
    p0 = eye(n);
end
W = A * spdiags(sum(A)'.^(-1), 0, n, n);
p = p0;
pl2norm = inf;
unchanged = 0;
for i = 1:nSteps
    pnew = (1-laziness) .* W * p + laziness .* p0;
    l2norm = max(sqrt(sum((pnew - p).^2)))
    p = pnew;
    if (l2norm < eps)
        break;
    else
        if (l2norm == pl2norm)
            unchanged = unchanged +1
            if (unchanged > 10)
                break;
            end
        else
            unchanged = 0
            pl2norm = l2norm;
        end
    end
end