function net = getCoexpNetEuclideanRank(expr, max_rank)

%% net = getCoexpNet(expr, min_cc, max_rank)
%% construct a WEIGHTED gene co-expression network given a gene expression data
%% expr: gene expression data. Each row is a gene, each column is a sample
%% min_cc: threshold on Pearson Correlation Coefficient
%% max_rank: threshold on the ranks of the correlation coeffient values

y = pdist(expr);
D = squareform(y);
n = size(expr, 1);

[Y, I] = sort(D);
[Y, I] = sort(I);
net = sparse(I <= max_rank + 1);

net = max(net, net');
net = net - sparse(1:n, 1:n, 1);