% identify_neighbor
%
% Purpose of this function is to construct a patient-patient network
% and apply Random Walk with Restart on that network
%
% Usage: To construct a patient-patient network on data file 'data' 
% with 3 patients connected to each patient on the network and apply
% Random Walk with Restart on that network use identify_neighbor(data,3)  
%
% 'rwmatrix' contain probabilities for random walker to start from one
% node and end with another node

function rwmatrix = identify_neighbor(data, neighbor_size)

    % construct patient-patient network
    net = getCoexpNetEuclideanRank(data,neighbor_size);
    
    % RWR on patient-patient network
    rw = RWR(net, 1000, 0.3);
    
    % remove probability of returning start node
    rwmatrix = rw-diag(diag(rw));

end